#!/paket/tcl/bin/wish8.0 -f









proc maske {} {
  global m
  frame .f
  message .f.title -text Banken -aspect 1000 -font "Times 24 bold"
  pack .f.title -padx 10 -pady 10
   frame .f.feld1
   label .f.feld1.blzlabel -text "Blz:"
   entry .f.feld1.blzentry -textvariable m(blz) -relief sunken -width 10
   pack .f.feld1.blzlabel -side left -anchor w 
   pack .f.feld1.blzentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld1 -side top -fill x -pady 6

   frame .f.feld2
   label .f.feld2.banknamelabel -text "Bankname:"
   entry .f.feld2.banknameentry -textvariable m(bankname) -relief sunken -width 30
   pack .f.feld2.banknamelabel -side left -anchor w 
   pack .f.feld2.banknameentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld2 -side top -fill x -pady 6

   frame .f.b
   button .f.b.suchen -text "Suchen" -command suchen
   button .f.b.clear  -text "Maske frei" -command clearfields
   button .f.b.speichern -text "Speichern" -command speichern
   button .f.b.end -text "Ende" -command ende
   pack  .f.b.suchen  -side left -fill x -expand 1
   pack  .f.b.clear   -side left -fill x -expand 1
   pack  .f.b.speichern -side left -fill x -expand 1
   pack  .f.b.end -side left -fill x -expand 1
   pack  .f.b -fill x -expand 1
   
   label .f.msg -text "" -relief sunken -bd 1 -anchor w
   pack  .f.msg  -side left -padx 2 -expand yes -fill both
   pack .f
}
proc clearfields {} {
 global m status
 foreach f {  blz bankname } {
   set m($f) ""
 }
 set status new
}

proc savefields {} {
  global m s
  foreach f {  blz bankname } {
    set s($f) $m($f)
  }
}

proc speichern {} {
  global m s env cursor adamsg logon status
  if { $status == "found" } {
    set anw "UPDATE BANKEN SET ";
    set fc 0

   if { $s(blz) != $m(blz) } {
      if { $fc > 0 } { append anw "," }
      append anw "blz='$m(blz)'"
      incr fc
   }

   if { $s(bankname) != $m(bankname) } {
      if { $fc > 0 } { append anw "," }
      append anw "bankname='$m(bankname)'"
      incr fc
   }

    if { $fc > 0 } {
            append anw " WHERE blz='$m(blz)'"
    } else {
      setmsg "Nichts gendert "
      return
    }
  } else {
    set anw "INSERT INTO BANKEN SET blz='$m(blz)',bankname='$m(bankname)'"
  }
  puts stdout $anw
  catch { adasql $cursor $anw } fehler
  if { $adamsg(rc)==0 } {
    adacommit $logon
    setmsg "Satz $m(blz) gespeichert "
    savefields
  } else {
    setmsg "Error $adamsg(rc):$adamsg(errortxt)"
  }
}


proc gensuchanw {} {
  global m 
  set anw "SELECT * FROM BANKEN"
  set fc 0

   if { [string length [string trim $m(blz)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(blz)] {
        append anw "blz LIKE '$m(blz)'"
     } else {
        append anw "blz = '$m(blz)'"
     }
     incr fc
   }

   if { [string length [string trim $m(bankname)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(bankname)] {
        append anw "bankname LIKE '$m(bankname)'"
     } else {
        append anw "bankname = '$m(bankname)'"
     }
     incr fc
   }

  return $anw
}


proc ende {} {
 puts "Und Tsch "
 exit
}

proc setmsg { msg } {
   if [regexp ^Error $msg] {
        .f.msg configure -text $msg -foreground red
    } else {
        set defaultColor [lindex [.f.msg configure -foreground] 3]
        .f.msg configure -text $msg -foreground $defaultColor
    }
}

proc suchen {} {
  global m cursor adamsg status
  if { [string length [string trim $m(blz)]]!=0 } {
    sucheschl $m(blz) 
  } else {
    freiesuche [ gensuchanw ] { sucheschl $key }
  }
}

proc sucheschl { key } {
  global m cursor adamsg status	
  set stat "SELECT BLZ,BANKNAME INTO :m(blz),:m(bankname) FROM BANKEN WHERE blz='$key'"
  
  puts stdout $stat;
  clearfields
  catch { adasql $cursor $stat } fehler
  if { $adamsg(rc)==0 } {
    setmsg ""
    savefields
    set status found
  } else {
    setmsg "Error $adamsg(rc) $adamsg(errortxt)"
    set status new
    set m(blz) $key
  }
}

# Auswahlfenster
proc displayauswahl { title } {
  global auswahlfenster
  set auswahlfenster "da"
  toplevel .auswahl
  wm title .auswahl "Suchergebnisse"
  frame   .auswahl.f
  listbox .auswahl.f.anzeige -yscrollcommand ".auswahl.f.sb set"
  scrollbar .auswahl.f.sb -command ".auswahl.f.anzeige yview"
  pack   .auswahl.f.anzeige .auswahl.f.sb -side left -fill y
  pack   .auswahl.f -fill x
  button .auswahl.dismiss -text "Dismiss" -command "destroy .auswahl; set auswahlfenster weg"
  pack .auswahl.dismiss -side bottom -fill x

  bind .auswahl.f.anzeige <Double-Button-1> {
    global auswahlfensterscript  
    set key [lindex [.auswahl.f.anzeige get [ .auswahl.f.anzeige curselection ]] 0 ]
    eval $auswahlfensterscript
  }
}

proc clearauswahl {} {
  .auswahl.f.anzeige delete 0 end
}

proc freiesuche { anw script } {
  global adamsg cursor auswahlfensterscript auswahlfenster

  set auswahlfensterscript $script
  puts $anw
  if { $auswahlfenster == "weg" } {
      displayauswahl "Auswahl"
  } else {
      clearauswahl
  }
    
  catch { adasql $cursor $anw } fehler
  if { $adamsg(rc)!=0 } {
    setmsg "Error $adamsg(rc) $adamsg(errortxt)"
    return 
  }
  set cols [adacols $cursor]
  array set r [ adafetch $cursor -array 1]
  while { $adamsg(rc) == 0 } {
    set zeile ""
    foreach c $cols {
      append zeile "$r($c) "
    }
    .auswahl.f.anzeige insert end $zeile
    array set r [ adafetch $cursor -array 1]
  }
}

source /paket/mmims/bin/adastart.tcl
set status new
set auswahlfenster "weg"
ermtkcompat
loadAdabastcl
getDbnameUserPassword "Authorisierung Adabas " adaConnect
setdateformat eur
maske

