#!/paket/tcl/bin/wish8.0 -f






  

 





 



 






proc maske {} {
  global m
  frame .f
  message .f.title -text Adressen -aspect 1000 -font "Times 24 bold"
  pack .f.title -padx 10 -pady 10
   frame .f.feld1
   label .f.feld1.loginlabel -text "Login:"
   entry .f.feld1.loginentry -textvariable m(login) -relief sunken -width 15
   pack .f.feld1.loginlabel -side left -anchor w 
   pack .f.feld1.loginentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld1 -side top -fill x -pady 6

   frame .f.feld2
   label .f.feld2.anredelabel -text "Anrede:"
   menubutton .f.feld2.anrede -text "Herr" -relief sunken -menu .f.feld2.anrede.menu
   menu .f.feld2.anrede.menu

   .f.feld2.anrede.menu add command -label "Herr" -command { set m(anrede) "H"}
   .f.feld2.anrede.menu add command -label "Frau" -command { set m(anrede) "F"}
   .f.feld2.anrede.menu add command -label "Firma" -command { set m(anrede) "G"}
   trace variable m(anrede) w initanrede
   pack .f.feld2.anredelabel -side left -anchor w 
   pack .f.feld2.anrede -side left -expand 1 -pady 3 -anchor w
   pack .f.feld2 -side top -fill x -pady 6

   label .f.feld2.namelabel -text "Name:"
   entry .f.feld2.nameentry -textvariable m(name) -relief sunken -width 40
   pack .f.feld2.namelabel -side left -anchor w 
   pack .f.feld2.nameentry -side left -expand 1 -pady 3 -anchor w

   label .f.feld2.vornamelabel -text "Vorname:"
   entry .f.feld2.vornameentry -textvariable m(vorname) -relief sunken -width 30
   pack .f.feld2.vornamelabel -side left -anchor w 
   pack .f.feld2.vornameentry -side left -expand 1 -pady 3 -anchor w

   frame .f.feld3
   label .f.feld3.strasselabel -text "Strasse:"
   entry .f.feld3.strasseentry -textvariable m(strasse) -relief sunken -width 40
   pack .f.feld3.strasselabel -side left -anchor w 
   pack .f.feld3.strasseentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld3 -side top -fill x -pady 6

   frame .f.feld4
   label .f.feld4.plzlabel -text "Plz:"
   entry .f.feld4.plzentry -textvariable m(plz) -relief sunken -width 7
   pack .f.feld4.plzlabel -side left -anchor w 
   pack .f.feld4.plzentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld4 -side top -fill x -pady 6

   label .f.feld4.ortlabel -text "Ort:"
   entry .f.feld4.ortentry -textvariable m(ort) -relief sunken -width 30
   pack .f.feld4.ortlabel -side left -anchor w 
   pack .f.feld4.ortentry -side left -expand 1 -pady 3 -anchor w

   frame .f.feld5
   label .f.feld5.telnrlabel -text "Telnr:"
   entry .f.feld5.telnrentry -textvariable m(telnr) -relief sunken -width 15
   pack .f.feld5.telnrlabel -side left -anchor w 
   pack .f.feld5.telnrentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld5 -side top -fill x -pady 6

   label .f.feld5.faxlabel -text "Fax:"
   entry .f.feld5.faxentry -textvariable m(fax) -relief sunken -width 15
   pack .f.feld5.faxlabel -side left -anchor w 
   pack .f.feld5.faxentry -side left -expand 1 -pady 3 -anchor w

   frame .f.feld6
   label .f.feld6.bemerkunglabel -text "Bemerkung:"
   entry .f.feld6.bemerkungentry -textvariable m(bemerkung) -relief sunken -width 80
   pack .f.feld6.bemerkunglabel -side left -anchor w 
   pack .f.feld6.bemerkungentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld6 -side top -fill x -pady 6

   frame .f.b
   button .f.b.suchen -text "Suchen" -command suchen
   button .f.b.clear  -text "Maske frei" -command clearfields
   button .f.b.speichern -text "Speichern" -command speichern
   button .f.b.end -text "Ende" -command ende
   pack  .f.b.suchen  -side left -fill x -expand 1
   pack  .f.b.clear   -side left -fill x -expand 1
   pack  .f.b.speichern -side left -fill x -expand 1
   pack  .f.b.end -side left -fill x -expand 1
   pack  .f.b -fill x -expand 1
   
   label .f.msg -text "" -relief sunken -bd 1 -anchor w
   pack  .f.msg  -side left -padx 2 -expand yes -fill both
   pack .f
}
proc clearfields {} {
 global m status
 foreach f {  login anrede name vorname strasse plz ort telnr fax bemerkung } {
   set m($f) ""
 }
 set status new
}

proc savefields {} {
  global m s
  foreach f {  login anrede name vorname strasse plz ort telnr fax bemerkung } {
    set s($f) $m($f)
  }
}

proc initanrede {Varname Elemname Operation} {
  set Varname ${Varname}($Elemname)
  upvar $Varname inhalt
  switch $inhalt {
  H { .f.feld2.anrede configure -text "Herr" }
  F { .f.feld2.anrede configure -text "Frau" }
  G { .f.feld2.anrede configure -text "Firma" }
   default { .f.feld2.anrede configure -text "Herr" ; set inhalt "H" }
  }
}

proc speichern {} {
  global m s env cursor adamsg logon status
  if { $status == "found" } {
    set anw "UPDATE ADRESSEN SET ";
    set fc 0

   if { $s(login) != $m(login) } {
      if { $fc > 0 } { append anw "," }
      append anw "login='$m(login)'"
      incr fc
   }

   if { $s(anrede) != $m(anrede) } {
      if { $fc > 0 } { append anw "," }
      append anw "anrede='$m(anrede)'"
      incr fc
   }

   if { $s(name) != $m(name) } {
      if { $fc > 0 } { append anw "," }
      append anw "name='$m(name)'"
      incr fc
   }

   if { $s(vorname) != $m(vorname) } {
      if { $fc > 0 } { append anw "," }
      append anw "vorname='$m(vorname)'"
      incr fc
   }

   if { $s(strasse) != $m(strasse) } {
      if { $fc > 0 } { append anw "," }
      append anw "strasse='$m(strasse)'"
      incr fc
   }

   if { $s(plz) != $m(plz) } {
      if { $fc > 0 } { append anw "," }
      append anw "plz='$m(plz)'"
      incr fc
   }

   if { $s(ort) != $m(ort) } {
      if { $fc > 0 } { append anw "," }
      append anw "ort='$m(ort)'"
      incr fc
   }

   if { $s(telnr) != $m(telnr) } {
      if { $fc > 0 } { append anw "," }
      append anw "telnr='$m(telnr)'"
      incr fc
   }

   if { $s(fax) != $m(fax) } {
      if { $fc > 0 } { append anw "," }
      append anw "fax='$m(fax)'"
      incr fc
   }

   if { $s(bemerkung) != $m(bemerkung) } {
      if { $fc > 0 } { append anw "," }
      append anw "bemerkung='$m(bemerkung)'"
      incr fc
   }

    if { $fc > 0 } {
      append anw ",aendzeit=TIMESTAMP,aendtaeter='$env(USER)'"
      append anw " WHERE login='$m(login)'"
    } else {
      setmsg "Nichts gendert "
      return
    }
  } else {
    set anw "INSERT INTO ADRESSEN SET login='$m(login)',anrede='$m(anrede)',name='$m(name)',vorname='$m(vorname)',strasse='$m(strasse)',plz='$m(plz)',ort='$m(ort)',telnr='$m(telnr)',fax='$m(fax)',bemerkung='$m(bemerkung)',aendzeit=TIMESTAMP,aendtaeter='$env(USER)'"
  }
  puts stdout $anw
  catch { adasql $cursor $anw } fehler
  if { $adamsg(rc)==0 } {
    adacommit $logon
    setmsg "Satz $m(login) gespeichert "
    savefields
  } else {
    setmsg "Error $adamsg(rc):$adamsg(errortxt)"
  }
}


proc gensuchanw {} {
  global m 
  set anw "SELECT LOGIN,NAME,VORNAME FROM ADRESSEN"
  set fc 0

   if { [string length [string trim $m(login)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(login)] {
        append anw "login LIKE '$m(login)'"
     } else {
        append anw "login = '$m(login)'"
     }
     incr fc
   }

   if { [string length [string trim $m(name)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(name)] {
        append anw "name LIKE '$m(name)'"
     } else {
        append anw "name = '$m(name)'"
     }
     incr fc
   }

   if { [string length [string trim $m(vorname)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(vorname)] {
        append anw "vorname LIKE '$m(vorname)'"
     } else {
        append anw "vorname = '$m(vorname)'"
     }
     incr fc
   }

   if { [string length [string trim $m(strasse)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(strasse)] {
        append anw "strasse LIKE '$m(strasse)'"
     } else {
        append anw "strasse = '$m(strasse)'"
     }
     incr fc
   }

   if { [string length [string trim $m(plz)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(plz)] {
        append anw "plz LIKE '$m(plz)'"
     } else {
        append anw "plz = '$m(plz)'"
     }
     incr fc
   }

   if { [string length [string trim $m(ort)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(ort)] {
        append anw "ort LIKE '$m(ort)'"
     } else {
        append anw "ort = '$m(ort)'"
     }
     incr fc
   }

   if { [string length [string trim $m(telnr)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(telnr)] {
        append anw "telnr LIKE '$m(telnr)'"
     } else {
        append anw "telnr = '$m(telnr)'"
     }
     incr fc
   }

   if { [string length [string trim $m(fax)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(fax)] {
        append anw "fax LIKE '$m(fax)'"
     } else {
        append anw "fax = '$m(fax)'"
     }
     incr fc
   }

   if { [string length [string trim $m(bemerkung)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(bemerkung)] {
        append anw "bemerkung LIKE '$m(bemerkung)'"
     } else {
        append anw "bemerkung = '$m(bemerkung)'"
     }
     incr fc
   }

  return $anw
}


proc ende {} {
 puts "Und Tsch "
 exit
}

proc setmsg { msg } {
   if [regexp ^Error $msg] {
        .f.msg configure -text $msg -foreground red
    } else {
        set defaultColor [lindex [.f.msg configure -foreground] 3]
        .f.msg configure -text $msg -foreground $defaultColor
    }
}

proc suchen {} {
  global m cursor adamsg status
  if { [string length [string trim $m(login)]]!=0 } {
    sucheschl $m(login) 
  } else {
    freiesuche [ gensuchanw ] { sucheschl $key }
  }
}

proc sucheschl { key } {
  global m cursor adamsg status	
  set stat "SELECT LOGIN,ANREDE,NAME,VORNAME,STRASSE,PLZ,ORT,TELNR,FAX,BEMERKUNG INTO :m(login),:m(anrede),:m(name),:m(vorname),:m(strasse),:m(plz),:m(ort),:m(telnr),:m(fax),:m(bemerkung) FROM ADRESSEN WHERE login='$key'"
  
  puts stdout $stat;
  clearfields
  catch { adasql $cursor $stat } fehler
  if { $adamsg(rc)==0 } {
    setmsg ""
    savefields
    set status found
  } else {
    setmsg "Error $adamsg(rc) $adamsg(errortxt)"
    set status new
    set m(login) $key
  }
}

# Auswahlfenster
proc displayauswahl { title } {
  global auswahlfenster
  set auswahlfenster "da"
  toplevel .auswahl
  wm title .auswahl "Suchergebnisse"
  frame   .auswahl.f
  listbox .auswahl.f.anzeige -yscrollcommand ".auswahl.f.sb set"
  scrollbar .auswahl.f.sb -command ".auswahl.f.anzeige yview"
  pack   .auswahl.f.anzeige .auswahl.f.sb -side left -fill y
  pack   .auswahl.f -fill x
  button .auswahl.dismiss -text "Dismiss" -command "destroy .auswahl; set auswahlfenster weg"
  pack .auswahl.dismiss -side bottom -fill x

  bind .auswahl.f.anzeige <Double-Button-1> {
    global auswahlfensterscript  
    set key [lindex [.auswahl.f.anzeige get [ .auswahl.f.anzeige curselection ]] 0 ]
    eval $auswahlfensterscript
  }
}

proc clearauswahl {} {
  .auswahl.f.anzeige delete 0 end
}

proc freiesuche { anw script } {
  global adamsg cursor auswahlfensterscript auswahlfenster

  set auswahlfensterscript $script
  puts $anw
  if { $auswahlfenster == "weg" } {
      displayauswahl "Auswahl"
  } else {
      clearauswahl
  }
    
  catch { adasql $cursor $anw } fehler
  if { $adamsg(rc)!=0 } {
    setmsg "Error $adamsg(rc) $adamsg(errortxt)"
    return 
  }
  set cols [adacols $cursor]
  array set r [ adafetch $cursor -array 1]
  while { $adamsg(rc) == 0 } {
    set zeile ""
    foreach c $cols {
      append zeile "$r($c) "
    }
    .auswahl.f.anzeige insert end $zeile
    array set r [ adafetch $cursor -array 1]
  }
}

source /paket/mmims/bin/adastart.tcl
set status new
set auswahlfenster "weg"
ermtkcompat
loadAdabastcl
getDbnameUserPassword "Authorisierung Adabas " adaConnect
setdateformat eur
maske

